<?php

defined('MOODLE_INTERNAL') || die;

require_once($CFG->libdir . '/formslib.php');

class course_dup_form extends moodleform {
    function definition() {
        global $courseid;
        $mform =& $this->_form;
        
        $mform->addElement('hidden', 'courseid', $courseid);
        $mform->addElement('header', 'general', get_string('general', 'block_course_duplicate'));

        /* Actual params follow. Make sure they're in sync with
           local_stag_course_external::stag_create_course_parameters */

//         $mform->addElement('select', 'category', get_string('category', 'block_course_duplicate'),  $this->_customdata['categories']);
//         $mform->addRule('category', "Missing category", 'required', null, 'client');

        $mform->addElement('text', 'shortname', get_string('shortname', 'block_course_duplicate'));
        $mform->addRule('shortname', "Missing shortname", 'required', null, 'client');

        $mform->addElement('text', 'full_name', get_string('full_name', 'block_course_duplicate'));
        $mform->addRule('full_name', "Missing full course name", 'required', null, 'client');

        $mform->addElement('textarea', 'annotation', get_string('annotation', 'block_course_duplicate'), 'rows="10" cols="50"');
        $mform->addRule('annotation', "Missing course annotation", 'required', null, 'client');

        $mform->addElement('date_selector', 'start_date', get_string('start_date', 'block_course_duplicate'));
        $mform->addRule('start_date', "Missing course start date", 'required', null, 'client');

        $mform->addElement('header', "stag_id", get_string('stag_id', 'block_course_duplicate'));
        $mform->addElement('select', 'stag_department', get_string('stag_department', 'block_course_duplicate'), $this->_customdata['stag_departments']);
        $mform->addElement('select', 'stag_subject', get_string('stag_subject', 'block_course_duplicate'), $this->_customdata['stag_subjects']);
        $mform->addElement('text', 'stag_year', get_string('stag_year', 'block_course_duplicate'));

        $mform->addElement('header', 'stag_parms', get_string('stag_parms', 'block_course_duplicate'));

        $mform->addElement('text', 'stag_roakidno', get_string('stag_roakidno', 'block_course_duplicate'));

        $mform->addElement('advcheckbox', 'stag_sync', get_string('stag_sync', 'block_course_duplicate'));

        $this->add_action_buttons(false, get_string('create_button', 'block_course_duplicate'));
    }
}
