$(document).ready(function() {
	var course_duplicate = new CourseDuplicate();
	course_duplicate
					// hodnoty se vypisuji pomoci php v duplicate.php
					.setReadonlyShortname(readonly_shortname)
					.setZkratkaPredmet(zkratka_predmet)
					.setPredmetBz(predmet_bz)
					.setArrRok(arr_rok)
					.setArrSemestr(arr_semestr)
					.setArrAnotace(arr_anotace)
					.setArrFaculty(arr_faculty)
					.setArrSubDep(arr_sub_dep)
					.setSepSn(sep_sn)
					.setSepFn(sep_fn)
					.setSepCa(sep_ca)
					// uz normalni init...
					.init()
					;
});

/**
 * pokud je shortname zadano pomoci stag id, pak znemozni jeho editaci
 * @returns {CourseDuplicate}
 */
function CourseDuplicate() {
	/** @param {CourseDuplicate} */
	var self = this;
	var trigger_class = 'readonly_shortname_trigger';
	var id_shortname = 'id_shortname';
	var id_fullname = 'id_full_name';
	var input_shortname = null;
	var input_fullname = null;
	var disable = null;
	var id_stag_subject;

	// prijdou z php
	var readonly_shortname;
	var zkratka_predmet;
	var predmet_bz;
	var arr_rok;
	var arr_semestr;
	var arr_anotace;
	var arr_faculty;
	var arr_sub_dep;
	var sep_sn;
	var sep_fn;
	var sep_ca;

	var zkratka;
	var rok;
	var nazev;
	var semestr;
	var fakulta;
	var katedra;
	var anotace;

	var submit_continue=true;
	var submit_alert='';

	var zkracenyNazev;
	var celyNazev;
	var nazevKategorie;

	var id_stag_department;
	var id_stag_subject;
	var id_stag_year;

	var selected_id_stag_department=$('#id_stag_department').find('option[value=0]');
	var selected_id_stag_subject=$('#id_stag_subject').find('option[value=0]');

	var value_stag_department;

	/**
	 * @returns {CourseDuplicate}
	 */
	this.init = function() {
		input_shortname = $('#' + id_shortname);
		input_fullname = $('#' + id_fullname);

		// doplneni trid pro pozdejsi snazsi zpracovani a kravinek pro IE
		var index=0;
		$('#id_stag_subject option').each(function(){
			$(this).addClass(arr_sub_dep[index]);
			index++;
		});

		// manualni zmena kratkeho nazvu
		input_shortname.change(function() {
			self
							.reset()
							.checkDuplicity();
		});
		// automaticka zmena kratkeho nazvu (nastaveni stag id)
		$('select#id_stag_department, select#id_stag_subject, input#id_stag_year').addClass(trigger_class).change(function(event) {
			self
							.reset()
							.changeStagId(event)
							.setShortname()
							.checkDuplicity()
							.enableDisableShortname()
			;
		});
		// kontrola pri odeslani
		/**
		 * @todo Vlahovic, 8.11.13 16:26: upravit kontrolu o overeni unikatnosti jinak, nebo zjistit, proc to nefunguje
		 * @param {object} event
		 */
		$('#id_submitbutton').click(function(event){
			self
							.reset()
//							.checkDuplicity()
							.controlInfo()
							.controlStagId()
							.submitForm(event);
		});
		return self;
	};

	/**
	 * kdyz je automaticky vyplnene shortname (a je nastaveno v configu) pak znemozni jeho editaci
	 * @returns {CourseDuplicate}
	 */
	this.enableDisableShortname = function() {
		if (readonly_shortname) {
			disable = true;
			$('.' + trigger_class).each(function() {
				var value = $(this).val();
				if (!value) {
					disable = false;
				}
			});
			if (disable) {
				input_shortname
								.attr('readonly', 'readonly')
								.css('background-color', '#eee').css('border', '1px solid #bbb').css('color', '#666');
			}
			else {
				input_shortname.removeAttr('style').removeAttr('readonly');
			}
		}
		return self;
	};

	/*
	 * Funkce pro kontrolu duplicitnich kratkych nazvu
	 * @update Vlahovic, 5.11.13 9:01: doplnuje unikatni kratke nazvy
	 * @returns {CourseDuplicate}
	 */
	this.checkDuplicity = function() {
		var shortname = input_shortname.val();
		if (shortname) {
			$.ajax({
				type: "POST",
				url: "test_duplikace.php",
				data: "shortname=" + shortname,
				dataType: 'json',
				cache: false,
				async: false,
				success: function(returnData) {
					if (returnData.unique_shortname) {
						self.setUniqueShortnameSuccess(returnData.unique_shortname);
					}
					else {
						self.setUniqueShortnameError();
					}
				},
				error: function() {
					self.setUniqueShortnameError();
				}
			});
		}
		return self;
	};

	/**
	 * nastavuje unikatni nazev, ktery vrati ajax
	 * @param {string} unique_shortname
	 * @returns {CourseDuplicate}
	 */
	this.setUniqueShortnameSuccess = function(unique_shortname) {
		input_shortname.val(unique_shortname);
		input_shortname.removeAttr('style');
		$('#unique_shortname_error').remove();
		return self;
	};

	/**
	 * pokud se nepodari overit unikatnost kratkeho nazvu, tak to da najevo v gui
	 * @returns {CourseDuplicate}
	 */
	this.setUniqueShortnameError = function() {
		input_shortname.removeAttr('style').css('border', '2px solid red');
		if (!$('#unique_shortname_error').length) {
			input_shortname.parent('div').append('<span id="unique_shortname_error" style="color: red; margin-left: 1em;">Nepodařilo se ověřit unikátnost!</span>');
		}
		self.setSubmitError('Nepodařilo se ověřit unikátnost krátkého názvu kurzu.');
		return self;
	};

	/**
	 * nastavi chybovou hlasku a zastavi odeslani
	 * @param {string} msg
	 * @returns {CourseDuplicate}
	 */
	this.setSubmitError=function(msg){
		submit_continue=false;
		submit_alert+=msg+"\r\n";
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setShortname = function() {
		zkracenyNazev = null;
		celyNazev = null;

		self.setKatedra().setRok().setZkratka().setFakulta().setSemestr().setNazev().setAnotace();

		// pokud jsou naplneny vsechny potrebne promenne, vyplni se prislusna pole. Pokud ne, pole budou prazdna.
		if (zkratka && rok && semestr && nazev) {
			zkracenyNazev = zkratka + sep_sn + rok + sep_sn + semestr;
			celyNazev = nazev + ' (' + zkratka + sep_fn + rok + sep_fn + semestr + ')';

			if (fakulta && katedra) {
				nazevKategorie = fakulta + sep_ca + katedra + sep_ca + zkratka;
			}
		}
		input_shortname.val(zkracenyNazev);
		input_fullname.val(celyNazev);
		$('#id_stag_year').val(rok);
		$('#id_annotation').val(anotace);
		return self;
	};

	/**
	 * @param {object} event
	 * @returns {CourseDuplicate}
	 */
	this.submitForm=function(event){
		if (!submit_continue) {
			alert(submit_alert);
			event.stopPropagation();
			event.preventDefault();
			return false;
		}
		return true;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.reset=function(){
		id_stag_subject=null;
		katedra=null;
		rok=null;
		zkratka=null;
		fakulta=null;
		semestr=null;
		nazev=null;
		anotace=null;
		submit_continue=true;
		submit_alert='';
		return self;
	};

	this.setSelectedIdStagDepartment=function(){
		selected_id_stag_department=$('#id_stag_department option:selected');
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setIdStagDepartment=function(){
		id_stag_department=(selected_id_stag_department.val()>0 ? selected_id_stag_department.val() : false);
		return self;
	};

	this.setSelectedIdStagSubject=function(){
		selected_id_stag_subject=$('#id_stag_subject option:selected');
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setIdStagSubject=function(){
		id_stag_subject=(selected_id_stag_subject.val()>0 ? selected_id_stag_subject.val() : false);
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setIdStagYear=function(){
		id_stag_year=($('#id_stag_year option:selected').val()>0 ? $('#id_stag_year option:selected').val() : false);
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setValueStagDepartment=function(){
		value_stag_department=$('#id_stag_department option:selected').text();
		return self;
	};

	/**
	 * zmena plozek stag id
	 * @param {object} event
	 * @returns {CourseDuplicate}
	 */
	this.changeStagId=function(event){
		var changed_object=$(event.target);
		// zmena oddeleni
		if(changed_object.is('#id_stag_department')){
			self
							.setSelectedIdStagDepartment()
							.setIdStagDepartment()
							.setValueStagDepartment()

							.resetIdStagSubject()
							.setSelectedIdStagSubject()
							.setIdStagSubject()
							.filterIdStagSubject();
		}
		// zmena predmetu
		else if(changed_object.is('#id_stag_subject')){
			self
							.setSelectedIdStagSubject()
							.setIdStagSubject()
							.correctIdStagDepartment()
							.filterIdStagSubject();
		}
		// zmena roku
		else if(changed_object.is('#id_stag_year')){
			self
							.setIdStagDepartment()
							.setIdStagSubject()
							.setIdStagYear();
		}
		return self;
	};

	/**
	 * resetne vyber predmetu
	 * @returns {CourseDuplicate}
	 */
	this.resetIdStagSubject=function(){
		$('#id_stag_subject').find('option[value=0]').prop('selected', true);
		id_stag_subject=false;
		return self;
	};

	/**
	 * resetne vyber oddeleni
	 * @returns {CourseDuplicate}
	 */
	this.resetIdStagDepartment=function(){
		$('#id_stag_department').find('option[value=0]').prop('selected', true);
		id_stag_department=false;
		return self;
	};

	/**
	 * resetne rok
	 * @returns {CourseDuplicate}
	 */
	this.resetIdStagYear=function(){
		$('#id_stag_year').val('');
		return self;
	};

	/**
	 * vyfiltruje polozky selectboxu "predmet"
	 * @returns {CourseDuplicate}
	 */
	this.filterIdStagSubject=function(){
		// pred kazdou zmenou vsechno zobrazim... hlavne kvuli IE :-)
		self.showOptions($('#id_stag_subject').find('option'));
		// je zvolena polozka oddeleni - je co filtrovat
		if(id_stag_department){
			self
							.hideOptions($('#id_stag_subject').find('option'))
							.showOptions($('#id_stag_subject').find('option.Žádný'))
							.showOptions($('#id_stag_subject').find('option.'+value_stag_department))
			;
			if(id_stag_subject){
				$('#id_stag_subject').find('option[value='+id_stag_subject+']').prop('selected', true);
			}
			else{
				self.resetIdStagSubject();
			}
		}
		// neni nic zvoleno, tak nastavim selected na "zadny" opet kvuli IE :-)
		else{
			self.resetIdStagSubject();
		}
		return self;
	};

	/**
	 * @param {object} options
	 * @returns {CourseDuplicate}
	 */
	this.hideOptions=function(options){
		options.each(function(){
			self.hideOption($(this));
		});
		return self;
	};

	/**
	 * @param {object} option
	 * @returns {CourseDuplicate}
	 */
	this.hideOption=function(option){
		option.wrap((navigator.appName === 'Microsoft Internet Explorer') ? '<span>' : null).hide();
		return self;
	};

	/**
	 * @param {object} options
	 * @returns {CourseDuplicate}
	 */
	this.showOptions=function(options){
		options.each(function(){
			self.showOption($(this));
		});
		return self;
	};


	/**
	 * @param {object} option
	 * @returns {CourseDuplicate}
	 */
	this.showOption=function(option){
		if (navigator.appName === 'Microsoft Internet Explorer') {
			if (option.parent().is('span')) {
				var span = option.parent('span');
				$(span).replaceWith(option);
			}
			$(option).show().removeAttr('style');
		} else {
			option.show();
		}
		return self;
	};

	/**
	 * pri zmene predmetu zjisti zda je spravne nastaveno oddeleni a pokud ne tak ho nastavi
	 * @returns {CourseDuplicate}
	 */
	this.correctIdStagDepartment=function(){
		if(!id_stag_subject && id_stag_department){
			self.resetIdStagDepartment();
			self.setSelectedIdStagDepartment();
			self.setIdStagDepartment();
//			self.setValueStagDepartment()
			;
		}
		else if(id_stag_subject && selected_id_stag_subject.attr('class')!==selected_id_stag_department.text()){
			$('#id_stag_department option').each(function(){
				if($(this).text()===selected_id_stag_subject.attr('class')){
					$(this).attr('selected',true).prop('selected', true);
					id_stag_department=$(this).val();
					value_stag_department=$(this).text();
				}
			});
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.controlStagId=function(){
		var department=$('#id_stag_department').val();
		var subject=$('#id_stag_subject').val();
		var year=$('#id_stag_year').val();
		if(
						(department || subject || year) &&
						(!department || !subject || !year)
			){
			self.setSubmitError('Stag ID musí být zadané celé, nebo vůbec.');
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.controlInfo=function(){
		if(!$('#id_shortname').val()){
			self.setSubmitError('Krátký název kurzu musí být zadán.');
		}
		if(!$('#id_full_name').val()){
			self.setSubmitError('Celý název kurzu musí být zadán.');
		}
		if(!$('#id_annotation').val()){
			self.setSubmitError('Anotace kurzu musí být zadána.');
		}
		return self;
	};

	/* ************************************************************************ */
	/* nastaveni vsech promenych pred poskladanim shorname */
	/* ************************************************************************ */

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setKatedra = function(){
		if (id_stag_department) {
			katedra=value_stag_department;
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setRok = function() {
		var actual_year=(new Date).getFullYear();
		if (id_stag_subject) {
			// manualne jde zadat rok jen v rozmezi +- 10 let od aktualniho roku
			// nevyhovujici nebo nesmyslny retezec se prevede na aktualni rok
			if($('#id_stag_year').val()>0){
				rok=parseInt($('#id_stag_year').val());
				if(rok<(actual_year-10) || rok>(actual_year+10)){
					rok=null;
				}
			}
			if(!rok){
				rok = arr_rok[id_stag_subject];
				// pokud je promenna ROK prazdna, jako vychozi hodnota se vyplni aktualni rok
				if (!rok) {
					rok = actual_year;
				}
			}
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setZkratka=function(){
		if (id_stag_subject) {
			zkratka=zkratka_predmet[id_stag_subject];
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setFakulta=function(){
		if (id_stag_subject) {
			fakulta=arr_faculty[id_stag_subject];
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setSemestr=function(){
		if (id_stag_subject) {
			semestr=arr_semestr[id_stag_subject];
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setNazev=function(){
		if (id_stag_subject) {
			nazev=predmet_bz[id_stag_subject];
		}
		return self;
	};

	/**
	 * @returns {CourseDuplicate}
	 */
	this.setAnotace=function(){
		if(id_stag_subject) {
			anotace=arr_anotace[id_stag_subject];
		}
		return self;
	};

	/* ************************************************************************ */
	/* prijdou z php */
	/* ************************************************************************ */
	this.setReadonlyShortname = function(_readonly_shortname) {
		readonly_shortname = _readonly_shortname;
		return self;
	};

	this.setSepSn = function(_sep_sn) {
		sep_sn = _sep_sn;
		return self;
	};

	this.setSepFn = function(_sep_fn) {
		sep_fn = _sep_fn;
		return self;
	};

	this.setSepCa = function(_sep_ca) {
		sep_ca = _sep_ca;
		return self;
	};

	this.setZkratkaPredmet = function(_zkratka_predmet) {
		zkratka_predmet = _zkratka_predmet;
		return self;
	};

	this.setPredmetBz = function(_predmet_bz) {
		predmet_bz = _predmet_bz;
		return self;
	};

	this.setArrRok = function(_arr_rok) {
		arr_rok = _arr_rok;
		return self;
	};

	this.setArrSemestr = function(_arr_semestr) {
		arr_semestr = _arr_semestr;
		return self;
	};

	this.setArrAnotace = function(_arr_anotace) {
		arr_anotace = _arr_anotace;
		return self;
	};

	this.setArrFaculty = function(_arr_faculty) {
		arr_faculty = _arr_faculty;
		return self;
	};

	this.setArrSubDep = function(_arr_sub_dep) {
		arr_sub_dep = _arr_sub_dep;
		return self;
	};
}