<?php

require_once('../../config.php');
require_once($CFG->dirroot . '/local/courses/form.php');
require_once($CFG->dirroot . '/local/stag/attributes.php');

global $PAGE, $OUTPUT, $DB;

$id = required_param('id', PARAM_INT);

$course = $DB->get_record('course', array('id'=>$id), '*', MUST_EXIST);

require_login($course);
$context = context_course::instance($COURSE->id);

require_capability('moodle/course:update', $context);

$base_url = new moodle_url('/local/courses/index.php', array('id' => $course->id));
$PAGE->set_url($base_url);
$PAGE->set_pagelayout('course');
$PAGE->set_title(get_string('course') . ': ' . $course->fullname);
$PAGE->set_heading($course->fullname);

$form_params = array();
foreach (course_attrs_form::$stag_attributes as $attr) {
    $var = "stag_" . $attr;
    $$var = attribute_manager::get_attribute($course->id, $attr);
    $form_params[$attr] = $$var;
}

$form = new course_attrs_form(null, $form_params);
$data = $form->get_data();
if (!$data) {
    echo $OUTPUT->header();
    echo $OUTPUT->heading(get_string('courseattributessetting', 'local_courses'));
    $form->display();

    echo $OUTPUT->footer();
    die();
}

if(isset($data)) {
	$stag_id_control=false;

    /* Hodnoty z DB */
    $oddeleni       =   attribute_manager::get_attribute($course->id, 'department');
    $predmet        =   attribute_manager::get_attribute($course->id, 'subject');
    $rok            =   attribute_manager::get_attribute($course->id, 'year');

    /* Hodnoty z formulare */
    $frm_oddeleni   =   $data->stag_department;
    $frm_predmet    =   $data->stag_subject;
    $frm_rok        =   (int)$data->stag_year;

    /* Pokud se nejaka hodnota lisi, upravime verzi */
    if($oddeleni != $frm_oddeleni || $predmet != $frm_predmet || $rok != $frm_rok) {
        $maxVerze = $DB->get_records_sql('
					SELECT
						t4.course_id,
						max(t4.value) as max_ver
					FROM
						{course_attributes} t1,
						{course_attributes} t2,
						{course_attributes} t3,
						{course_attributes} t4
					WHERE
						t1.course_id=t2.course_id AND
						t1.name = "department" AND
						t1.value=? AND
						t2.name = "subject" AND
						t2.value = ? AND
						t1.course_id=t3.course_id AND
						t3.name="year" AND
						t3.value=? AND
						t1.course_id=t4.course_id AND
						t4.name="ver"
					order by t4.value desc',
								array( $frm_oddeleni , $frm_predmet , $frm_rok ));
        $maxVerzeKey = array_keys($maxVerze);
        $ver = 1;
        if($maxVerze[$maxVerzeKey[0]]->max_ver > 0) {
            $ver = $maxVerze[$maxVerzeKey[0]]->max_ver + 1;
        }

        attribute_manager::set_attribute($course->id, PARAM_INT, 'ver', $ver);
    }
}

// vsechno
if ((!empty($data->stag_department) && !empty($data->stag_subject) && !empty($data->stag_year))) {
	attribute_manager::set_attribute($course->id, PARAM_ALPHANUMEXT, 'department', $data->stag_department);
	attribute_manager::set_attribute($course->id, PARAM_ALPHANUMEXT, 'subject', $data->stag_subject);
	attribute_manager::set_attribute($course->id, PARAM_INT, 'year', $data->stag_year);
}
// nebo nic
elseif(empty($data->stag_department) && empty($data->stag_subject) && empty($data->stag_year)){
	attribute_manager::delete_attribute($course->id, 'department');
	attribute_manager::delete_attribute($course->id, 'subject');
	attribute_manager::delete_attribute($course->id, 'year');
	attribute_manager::delete_attribute($course->id, 'ver');
}

if (!empty($data->stag_roakidno))
    attribute_manager::set_attribute($course->id, PARAM_ALPHANUMEXT, 'roakidno', $data->stag_roakidno);

if (isset($data->stag_sync)) {
    attribute_manager::set_attribute($course->id, PARAM_BOOL, 'sync', $data->stag_sync);
}

if (isset($data->stag_template)) {

    if ($data->stag_template)
    {
      $result = $DB->get_records_sql('SELECT t4.course_id FROM {course_attributes} t1, {course_attributes} t2, {course_attributes} t3, {course_attributes} t4
                                      WHERE t1.course_id=t2.course_id AND t1.name = "department" AND t1.value=? AND t2.name = "subject" AND t2.value = ?
                                      AND t1.course_id=t3.course_id AND t3.name="year" AND t3.value=? AND t1.course_id=t4.course_id AND t4.name="template"',
                                      array( $form_params['department'] , $form_params['subject'] , $form_params['year'] ));

      $pom = array_keys($result);
      if (isset($pom[0]))
      {
        if ($course->id != $result[$pom[0]]->course_id)
          attribute_manager::set_attribute($result[$pom[0]]->course_id, PARAM_BOOL, 'template', 0);
      }
    }
    attribute_manager::set_attribute($course->id, PARAM_BOOL, 'template', $data->stag_template);

}

redirect($base_url);