<?php

/* must be run from the Moodle root directory */

defined('MOODLE_INTERNAL') || die();

require_once("local/stag/attributes.php");

class stag_attrs_test extends advanced_testcase {

    public function test_wrong_type() {
	$this->resetAfterTest(true);
	$course = $this->getDataGenerator()->create_course();

	try {
            attribute_manager::set_attribute($course->id, PARAM_URL, "key1", "1");
	} catch (moodle_exception $e) {
	    if ($e->errorcode == 'unknownattributetype')
		return 0;
	}
	$this->fail('The expected exception has not been thrown.');
    }

    public function test_add_attr() {
	global $DB;

	$this->resetAfterTest(true);
	$course = $this->getDataGenerator()->create_course();

        $val = attribute_manager::get_attribute($course->id, "pokus");
        $this->assertNull($val);

	attribute_manager::set_attribute($course->id, PARAM_ALPHANUMEXT, "pokus", "hodnota");

	$attr = $DB->get_record("course_attributes",
		    array("course_id" => $course->id, "name" => "pokus"),
		    '*', MUST_EXIST);

        $this->assertSame($attr->value, "hodnota");

        $val = attribute_manager::get_attribute($course->id, "pokus");
        $this->assertSame($val, "hodnota");

        attribute_manager::set_attribute($course->id, PARAM_ALPHANUMEXT, "pokus", "hodnota2");
	$attr = $DB->get_record("course_attributes", 
		     array("course_id" => $course->id, 'name' => "pokus"),
		     '*', MUST_EXIST);
	$this->assertSame($attr->value, "hodnota2");

	try {
	    attribute_manager::set_attribute($course->id, PARAM_BOOL, "pokus", TRUE);
	} catch (moodle_exception $e) {
	    if ($e->errorcode == 'conflictingttributetype')
		return 0;
	}
	$this->fail('The expected exception has not been thrown.');
    }

}
